from data import gameSettings
from scenemanager import sceneManager
import menu2
import scene
import player
import splash
class Game(object):
	def __init__(self):
		self.maxLevel = 1
	
	def PlayAsSelection(self, selection):
		sceneManager.RemoveLatestTakesOverScreen()
		gameSettings.playingAs = selection
		
	def StartMenuSelection(self, selection):
		
		if "Play Game" in selection: # in "Play Game":
			self.StartGame()
		elif selection in 'Play As':
			tempmenu = menu2.PlayAsMenu()
			sceneManager.AddTakeOver(tempmenu)
		elif selection in 'Load Game':
			pass##
		elif selection is 'About':
			sceneManager.AddTakeOver(splash.About())
		else:
			print 'start menu selection fell through:' +  selection + '.end'
			
	def StartGame(self):
		newPlayer = player.Player(gameSettings.playingAs)
		gameScene = scene.GameScene(newPlayer, gameSettings.currentLevel)
		sceneManager.SetScene(gameScene)

	def TryAgainMenuSelection(self, selection):
		newScene = None
		if selection in "Try Again":
			newPlayer = player.Player(gameSettings.playingAs)
			newScene = scene.GameScene(newPlayer, gameSettings.currentLevel)
		elif selection in "Main Menu":
			newScene = scene.StartScene()
		elif selection in "Exit":
			ika.Exit()
		
		sceneManager.SetScene(newScene)
	def PlayAgainMenuSelection(self, selection):
		newScene = None
		if selection in "Continue Playing":
			self.Continue()
			return
		elif selection in "Main Menu":
			newScene = scene.StartScene()
		elif selection in "Exit":
			ika.Exit()
		
		sceneManager.SetScene(newScene)
	
	def SaveProgressMenuSelection(self, selection):
		if selection in "Save Progress":
			import splash
			sceneManager.AddTakeOver(splash.Notice("Progress Saved"))
		elif selection in "Continue":
			self.Continue()
			return
			
	def Continue(self):
		gameSettings.currentLevel += 1
		if gameSettings.currentLevel > self.maxLevel:
			newScene = scene.BeatGameScene(gameSettings.playingAs)
		else:
			newPlayer = player.Player(gameSettings.playingAs)
			newScene = scene.GameScene(newPlayer, gameSettings.currentLevel)
				
		sceneManager.SetScene(newScene)
			
	def LevelCompleted(self, finishesFull):
		#verify win or loss
		if gameSettings.playingAs is 'Solids':
			if finishesFull:
				newScene = scene.LostScene()
			else:
				#record win as solids
				found = False
				for level in gameSettings.levelsCompletedAsSolids:
					if level == gameSettings.currentLevel:
						found = True
						break
				if not found:
					gameSettings.levelsCompletedAsSolids.append(gameSettings.currentLevel)
				
				newScene = scene.WonScene()
		else:
			if finishesFull:
				#record win as liquids
				found = False
				for level in gameSettings.levelsCompletedAsLiquids:
					if level == gameSettings.currentLevel:
						found = True
						break
				if not found:
					gameSettings.levelsCompletedAsLiquids.append(gameSettings.currentLevel)
				
				newScene = scene.WonScene()
			else:
				newScene = scene.LostScene()
				
		sceneManager.SetScene(newScene)
		
		
game = Game()